from fastapi import HTTPException, Header, Depends
from starlette import status

from api import get_conn
from model.wapi.cntl import APIToken


async def check_auth(authorization: str = Header(), conn=Depends(get_conn)) -> APIToken:
    token = None
    if authorization is not None:
        token = APIToken.from_token(conn, authorization)

    if token is None:
        raise HTTPException(
            status_code=status.HTTP_401_UNAUTHORIZED,
            detail='Incorrect or missing token',
        )
    return token
